import { EventEmitter } from "@angular/core";
import { ICustomValueAccessorHost, CustomValueAccessor } from "../util/custom-value-accessor";
export declare class SuiRadioButton<T> implements ICustomValueAccessorHost<T> {
    private _radioClasses;
    name: string;
    value: T;
    isChecked: boolean;
    currentValue: T;
    currentValueChange: EventEmitter<T>;
    isDisabled: boolean;
    isReadonly: boolean;
    readonly checkedAttribute: string | undefined;
    readonly isDisabledAttribute: string | undefined;
    constructor();
    onClick(): void;
    update(): void;
    writeValue(value: T): void;
}
export declare class SuiRadioButtonValueAccessor<T> extends CustomValueAccessor<T, SuiRadioButton<T>> {
    constructor(host: SuiRadioButton<T>);
}
