import { EventEmitter } from "@angular/core";
import { ICalendarItem } from "./calendar-item";
export declare abstract class CalendarView {
    renderedItems: ICalendarItem[][];
    protected _selectedDate?: Date;
    renderedDate: Date;
    selectedDate: Date | undefined;
    initialDate: Date | undefined;
    onDateSelected: EventEmitter<Date>;
    onZoomOut: EventEmitter<void>;
    constructor();
    abstract renderItems(): void;
    abstract nextDateRange(): void;
    abstract prevDateRange(): void;
    setDate(selected: ICalendarItem): void;
    zoomOut(): void;
}
