import { CalendarDateItem } from "../directives/calendar-item";
import { DatepickerService } from "../services/datepicker.service";
export declare enum CalendarViewType {
    Year = 0,
    Month = 1,
    Date = 2,
    Hour = 3,
    Minute = 4,
}
export declare type CalendarViewResult = [Date, CalendarViewType];
export declare abstract class CalendarView {
    private _type;
    private _service;
    service: DatepickerService | undefined;
    readonly renderedDate: Date;
    readonly selectedDate: Date | undefined;
    renderedItems: CalendarDateItem[][];
    constructor(viewType: CalendarViewType);
    abstract renderItems(): void;
    abstract nextDateRange(): void;
    abstract prevDateRange(): void;
    setDate(selected: CalendarDateItem): void;
    zoomOut(): void;
}
