var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Input } from "@angular/core";
export var CalendarViewType;
(function (CalendarViewType) {
    CalendarViewType[CalendarViewType["Year"] = 0] = "Year";
    CalendarViewType[CalendarViewType["Month"] = 1] = "Month";
    CalendarViewType[CalendarViewType["Date"] = 2] = "Date";
    CalendarViewType[CalendarViewType["Hour"] = 3] = "Hour";
    CalendarViewType[CalendarViewType["Minute"] = 4] = "Minute";
})(CalendarViewType || (CalendarViewType = {}));
var CalendarView = (function () {
    function CalendarView(viewType) {
        this._type = viewType;
    }
    Object.defineProperty(CalendarView.prototype, "service", {
        set: function (service) {
            if (service) {
                this._service = service;
                this.renderItems();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalendarView.prototype, "renderedDate", {
        get: function () {
            if (this._service) {
                return this._service.currentDate;
            }
            return new Date();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalendarView.prototype, "selectedDate", {
        get: function () {
            if (this._service) {
                return this._service.selectedDate;
            }
        },
        enumerable: true,
        configurable: true
    });
    CalendarView.prototype.setDate = function (selected) {
        if (this._service) {
            this._service.changeDate(selected.date, this._type);
            this.renderItems();
        }
    };
    CalendarView.prototype.zoomOut = function () {
        if (this._service) {
            this._service.zoomOut(this._type);
        }
    };
    return CalendarView;
}());
export { CalendarView };
__decorate([
    Input(),
    __metadata("design:type", DatepickerService),
    __metadata("design:paramtypes", [DatepickerService])
], CalendarView.prototype, "service", null);
//# sourceMappingURL=calendar-view.js.map