var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input } from "@angular/core";
import { SuiLocalizationService } from "../../util/services/localization.service";
import { CalendarDateItem } from "../directives/calendar-item";
import { CalendarView, CalendarViewType } from "./calendar-view";
import { Util } from "../../util/util";
var SuiCalendarDateView = (function (_super) {
    __extends(SuiCalendarDateView, _super);
    function SuiCalendarDateView(localizationService) {
        var _this = _super.call(this, CalendarViewType.Date) || this;
        _this.localizationService = localizationService;
        _this.firstDayOfWeek = _this.localizationService
            .getValues().datepicker.firstDayOfWeek;
        _this.renderItems();
        return _this;
    }
    Object.defineProperty(SuiCalendarDateView.prototype, "days", {
        get: function () {
            var _this = this;
            var days = this.localizationService.getValues().datepicker.weekdaysShort;
            return days.map(function (d, i) { return days[(i + _this.firstDayOfWeek) % days.length]; });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SuiCalendarDateView.prototype, "year", {
        get: function () {
            return this.renderedDate.getFullYear();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SuiCalendarDateView.prototype, "month", {
        get: function () {
            return this.localizationService
                .getValues().datepicker.months[this.renderedDate.getMonth()];
        },
        enumerable: true,
        configurable: true
    });
    SuiCalendarDateView.prototype.renderItems = function () {
        var _this = this;
        var monthStart = Util.Date.startOfMonth(Util.Date.clone(this.renderedDate));
        var month = monthStart.getMonth();
        monthStart.setDate((1 - monthStart.getDay() + this.firstDayOfWeek - 7) % 7);
        var dates = [];
        Util.Array.range(6 * 7).forEach(function (i) {
            var date = Util.Date.clone(monthStart);
            date.setDate(date.getDate() + i);
            var isActive = !!_this.selectedDate && Util.Date.datesEqual(date, _this.selectedDate);
            dates.push(new CalendarDateItem(date, date.getDate().toString(), date.getMonth() !== month, isActive));
        });
        this.renderedItems = Util.Array.group(dates, 7);
    };
    SuiCalendarDateView.prototype.nextDateRange = function () {
        this.renderedDate.setMonth(this.renderedDate.getMonth() + 1);
        this.renderItems();
    };
    SuiCalendarDateView.prototype.prevDateRange = function () {
        this.renderedDate.setMonth(this.renderedDate.getMonth() - 1);
        this.renderItems();
    };
    return SuiCalendarDateView;
}(CalendarView));
__decorate([
    Input(),
    __metadata("design:type", Number)
], SuiCalendarDateView.prototype, "firstDayOfWeek", void 0);
SuiCalendarDateView = __decorate([
    Component({
        selector: "sui-calendar-date-view",
        template: "\n<table class=\"ui celled center aligned unstackable table seven column day\">\n<thead>\n    <tr>\n        <th colspan=\"7\">\n            <span class=\"link\" (click)=\"zoomOut()\">{{ month }} {{ year }}</span>\n            <span class=\"prev link\" (click)=\"prevDateRange()\">\n                <i class=\"chevron left icon\"></i>\n            </span>\n            <span class=\"next link\" (click)=\"nextDateRange()\">\n                <i class=\"chevron right icon\"></i>\n            </span>\n        </th>\n    </tr>\n    <tr>\n        <th *ngFor=\"let day of days\">{{ day }}</th>\n    </tr>\n</thead>\n<tbody>\n    <tr *ngFor=\"let group of renderedItems\">\n        <td class=\"link\"\n            *ngFor=\"let item of group\"\n            [calendarItem]=\"item\"\n            calendarFocusable\n            (click)=\"setDate(item)\">{{ item.humanReadable }}\n        </td>\n    </tr>\n</tbody>\n</table>\n"
    }),
    __metadata("design:paramtypes", [SuiLocalizationService])
], SuiCalendarDateView);
export { SuiCalendarDateView };
//# sourceMappingURL=date-view.js.map