var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component } from "@angular/core";
import { CalendarView, CalendarViewType } from "./calendar-view";
import { SuiLocalizationService } from "../../util/services/localization.service";
import { CalendarTimeItem } from "../directives/calendar-item";
import { Util } from "../../util/util";
var SuiCalendarMinuteView = (function (_super) {
    __extends(SuiCalendarMinuteView, _super);
    function SuiCalendarMinuteView(localizationService) {
        var _this = _super.call(this, CalendarViewType.Minute) || this;
        _this.localizationService = localizationService;
        _this.renderItems();
        return _this;
    }
    Object.defineProperty(SuiCalendarMinuteView.prototype, "date", {
        get: function () {
            var month = this.localizationService
                .getValues().datepicker.months[this.renderedDate.getMonth()];
            var date = this.renderedDate.getDate();
            var year = this.renderedDate.getFullYear();
            return month + " " + date + ", " + year;
        },
        enumerable: true,
        configurable: true
    });
    SuiCalendarMinuteView.prototype.renderItems = function () {
        var _this = this;
        var dayStart = Util.Date.startOfHour(Util.Date.clone(this.renderedDate));
        var minutes = [];
        Util.Array.range(12).forEach(function (i) {
            var date = Util.Date.clone(dayStart);
            date.setMinutes(i * 5);
            var hs = Util.String.padLeft(date.getHours().toString(), 2, "0");
            var ms = Util.String.padLeft(date.getMinutes().toString(), 2, "0");
            var isActive = !!_this.selectedDate && Util.Date.minutesEqual(date, _this.selectedDate);
            minutes.push(new CalendarTimeItem(date, hs + ":" + ms, false, isActive));
        });
        this.renderedItems = Util.Array.group(minutes, 3);
    };
    SuiCalendarMinuteView.prototype.nextDateRange = function () {
        this.renderedDate.setDate(this.renderedDate.getDate() + 1);
        this.renderItems();
    };
    SuiCalendarMinuteView.prototype.prevDateRange = function () {
        this.renderedDate.setDate(this.renderedDate.getDate() - 1);
        this.renderItems();
    };
    return SuiCalendarMinuteView;
}(CalendarView));
SuiCalendarMinuteView = __decorate([
    Component({
        selector: "sui-calendar-minute-view",
        template: "\n<table class=\"ui celled center aligned unstackable table three column minute\">\n<thead>\n    <tr>\n        <th colspan=\"4\">\n            <span class=\"link\" (click)=\"zoomOut()\">{{ date }}</span>\n            <span class=\"prev link\" (click)=\"prevDateRange()\">\n                <i class=\"chevron left icon\"></i>\n            </span>\n            <span class=\"next link\" (click)=\"nextDateRange()\">\n                <i class=\"chevron right icon\"></i>\n            </span>\n        </th>\n    </tr>\n</thead>\n<tbody>\n    <tr *ngFor=\"let group of renderedItems\">\n        <td class=\"link\"\n            *ngFor=\"let item of group\"\n            [calendarItem]=\"item\"\n            calendarFocusable\n            (click)=\"setDate(item)\">{{ item.humanReadable }}\n        </td>\n    </tr>\n</tbody>\n</table>\n"
    }),
    __metadata("design:paramtypes", [SuiLocalizationService])
], SuiCalendarMinuteView);
export { SuiCalendarMinuteView };
//# sourceMappingURL=minute-view.js.map