var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component } from "@angular/core";
import { SuiLocalizationService } from "../../util/services/localization.service";
import { CalendarView, CalendarViewType } from "./calendar-view";
import { CalendarMonthItem } from "../directives/calendar-item";
import { Util } from "../../util/util";
var SuiCalendarMonthView = (function (_super) {
    __extends(SuiCalendarMonthView, _super);
    function SuiCalendarMonthView(localizationService) {
        var _this = _super.call(this, CalendarViewType.Month) || this;
        _this.localizationService = localizationService;
        _this.renderItems();
        return _this;
    }
    Object.defineProperty(SuiCalendarMonthView.prototype, "year", {
        get: function () {
            return this.renderedDate.getFullYear();
        },
        enumerable: true,
        configurable: true
    });
    SuiCalendarMonthView.prototype.renderItems = function () {
        var _this = this;
        var yearStart = Util.Date.startOfYear(Util.Date.clone(this.renderedDate));
        var months = [];
        Util.Array.range(12).forEach(function (m) {
            var date = Util.Date.clone(yearStart);
            date.setMonth(m);
            var hR = _this.localizationService.getValues().datepicker.monthsShort[m];
            var isActive = !!_this.selectedDate && Util.Date.monthsEqual(date, _this.selectedDate);
            months.push(new CalendarMonthItem(date, hR, false, isActive));
        });
        this.renderedItems = Util.Array.group(months, 3);
    };
    SuiCalendarMonthView.prototype.nextDateRange = function () {
        this.renderedDate.setFullYear(this.year + 1);
        this.renderItems();
    };
    SuiCalendarMonthView.prototype.prevDateRange = function () {
        this.renderedDate.setFullYear(this.year - 1);
        this.renderItems();
    };
    return SuiCalendarMonthView;
}(CalendarView));
SuiCalendarMonthView = __decorate([
    Component({
        selector: "sui-calendar-month-view",
        template: "\n<table class=\"ui celled center aligned unstackable table three column month\">\n<thead>\n    <tr>\n        <th colspan=\"3\">\n            <span class=\"link\" (click)=\"zoomOut()\">{{ year }}</span>\n            <span class=\"prev link\" (click)=\"prevDateRange()\">\n                <i class=\"chevron left icon\"></i>\n            </span>\n            <span class=\"next link\" (click)=\"nextDateRange()\">\n                <i class=\"chevron right icon\"></i>\n            </span>\n        </th>\n    </tr>\n</thead>\n<tbody>\n    <tr *ngFor=\"let group of renderedItems\">\n        <td class=\"link\"\n            *ngFor=\"let item of group\"\n            [calendarItem]=\"item\"\n            calendarFocusable\n            (click)=\"setDate(item)\">{{ item.humanReadable }}\n        </td>\n    </tr>\n</tbody>\n</table>\n"
    }),
    __metadata("design:paramtypes", [SuiLocalizationService])
], SuiCalendarMonthView);
export { SuiCalendarMonthView };
//# sourceMappingURL=month-view.js.map