var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component } from "@angular/core";
import { CalendarView, CalendarViewType } from "./calendar-view";
import { CalendarYearItem } from "../directives/calendar-item";
import { Util } from "../../util/util";
var SuiCalendarYearView = (function (_super) {
    __extends(SuiCalendarYearView, _super);
    function SuiCalendarYearView() {
        var _this = _super.call(this, CalendarViewType.Year) || this;
        _this.renderItems();
        return _this;
    }
    Object.defineProperty(SuiCalendarYearView.prototype, "decadeStart", {
        get: function () {
            return Math.floor(this.renderedDate.getFullYear() / 10) * 10 + 1;
        },
        enumerable: true,
        configurable: true
    });
    SuiCalendarYearView.prototype.renderItems = function () {
        var _this = this;
        var decadeStart = Util.Date.startOfYear(Util.Date.clone(this.renderedDate));
        decadeStart.setFullYear(this.decadeStart);
        var years = [];
        Util.Array.range(12, this.decadeStart).forEach(function (y) {
            var date = Util.Date.clone(decadeStart);
            date.setFullYear(y);
            var isActive = !!_this.selectedDate && Util.Date.yearsEqual(date, _this.selectedDate);
            years.push(new CalendarYearItem(date, date.getFullYear().toString(), false, isActive));
        });
        this.renderedItems = Util.Array.group(years, 3);
    };
    SuiCalendarYearView.prototype.nextDateRange = function () {
        this.renderedDate.setFullYear(this.renderedDate.getFullYear() + 10);
        this.renderItems();
    };
    SuiCalendarYearView.prototype.prevDateRange = function () {
        this.renderedDate.setFullYear(this.renderedDate.getFullYear() - 10);
        this.renderItems();
    };
    return SuiCalendarYearView;
}(CalendarView));
SuiCalendarYearView = __decorate([
    Component({
        selector: "sui-calendar-year-view",
        template: "\n<table class=\"ui celled center aligned unstackable table three column year\">\n<thead>\n    <tr>\n        <th colspan=\"3\">\n            <span class=\"link\" (click)=\"onZoomOut.emit()\">{{ decadeStart }} - {{ decadeStart + 10 }}</span>\n            <span class=\"prev link\" (click)=\"prevDateRange()\">\n                <i class=\"chevron left icon\"></i>\n            </span>\n            <span class=\"next link\" (click)=\"nextDateRange()\">\n                <i class=\"chevron right icon\"></i>\n            </span>\n        </th>\n    </tr>\n</thead>\n<tbody>\n    <tr *ngFor=\"let group of renderedItems\">\n        <td class=\"link\"\n            *ngFor=\"let item of group\"\n            [calendarItem]=\"item\"\n            calendarFocusable\n            (click)=\"setDate(item)\">{{ item.humanReadable }}\n        </td>\n    </tr>\n</tbody>\n</table>\n"
    }),
    __metadata("design:paramtypes", [])
], SuiCalendarYearView);
export { SuiCalendarYearView };
//# sourceMappingURL=year-view.js.map