import { ComponentRef, ElementRef, EventEmitter, OnDestroy } from "@angular/core";
import { PopupConfig } from "./popup-config";
import { SuiPopup } from "./popup";
import { SuiComponentFactory } from "../util/component-factory.service";
export interface IPopup {
    open(): void;
    close(): void;
    toggle(): void;
}
export declare abstract class SuiPopupController<T = undefined> implements IPopup, OnDestroy {
    private _element;
    private _componentFactory;
    protected _popupConfig: PopupConfig;
    private _componentRef;
    protected _contentComponentRef?: ComponentRef<T>;
    readonly activePopup: SuiPopup;
    private _openingTimeout;
    readonly onOpen: EventEmitter<void>;
    readonly onClose: EventEmitter<void>;
    constructor(_element: ElementRef, _componentFactory: SuiComponentFactory, _popupConfig: PopupConfig);
    open(): void;
    close(): void;
    toggle(): void;
    private onMouseEnter();
    private onMouseLeave();
    private onClick();
    onDocumentClick(e: MouseEvent): void;
    private onFocus();
    private onFocusOut();
    ngOnDestroy(): void;
}
