import { ComponentRef, ElementRef, OnDestroy } from "@angular/core";
import { PopupConfig } from "./popup-config";
import { SuiPopup } from "./popup";
import { SuiComponentFactory } from "../util/services/component-factory.service";
export interface IPopup {
    open(): void;
    close(): void;
    toggle(): void;
}
export declare abstract class SuiPopupController<T = undefined> implements IPopup, OnDestroy {
    private _element;
    private _componentFactory;
    private _componentRef;
    protected _contentComponentRef?: ComponentRef<T>;
    readonly popup: SuiPopup;
    private _openingTimeout;
    constructor(_element: ElementRef, _componentFactory: SuiComponentFactory, config: PopupConfig);
    open(): void;
    close(): void;
    toggle(): void;
    private onMouseEnter();
    private onMouseLeave();
    private onClick();
    onDocumentClick(e: MouseEvent): void;
    private onFocus();
    private onFocusOut();
    ngOnDestroy(): void;
}
