export declare type LookupFnResult<T> = T | Promise<T>;
export declare type LookupFn<T> = (query: string | undefined) => LookupFnResult<T> | LookupFnResult<T[]>;
export declare type QueryLookupFn<T> = (query: string) => LookupFnResult<T[]>;
export declare type ItemLookupFn<T, U> = (query: string | undefined, initial: U) => LookupFnResult<T>;
export declare type ItemsLookupFn<T, U> = (query: string | undefined, initial: U[]) => LookupFnResult<T[]>;
export declare class SearchService<T> {
    private _options;
    private _optionsLookup?;
    private _optionsField?;
    options: T[];
    optionsLookup: LookupFn<T> | undefined;
    readonly queryLookup: QueryLookupFn<T>;
    readonly hasItemLookup: boolean;
    optionsField: string | undefined;
    private _results;
    private _resultsCache;
    readonly results: T[];
    private _query;
    allowEmptyQuery: boolean;
    searchDelay: number;
    private _searchDelayTimeout;
    private _isSearching;
    readonly query: string;
    readonly isSearching: boolean;
    constructor(allowEmptyQuery?: boolean);
    updateQueryDelayed(query: string, callback?: (err?: Error) => void): void;
    updateQuery(query: string, callback?: (err?: Error) => void): void;
    private updateResults(results);
    itemLookup<U>(initial: U): LookupFnResult<T>;
    itemsLookup<U>(initial: U[]): LookupFnResult<T[]>;
    private toRegex(query);
    highlightMatches(text: string): string;
    private reset();
}
