import { ElementRef, Renderer2, EventEmitter, AfterViewInit } from "@angular/core";
import { SuiSelectBase } from "./select-base";
import { CustomValueAccessor, ICustomValueAccessorHost } from "../util/custom-value-accessor";
export declare class SuiMultiSelect<T, U> extends SuiSelectBase<T, U> implements AfterViewInit, ICustomValueAccessorHost<U[]> {
    selectedOptions: T[];
    private _writtenOptions?;
    private _renderedSelectedOptions;
    private _renderedSelectedSubscriptions;
    selectedOptionsChange: EventEmitter<U[]>;
    readonly availableOptions: T[];
    maxSelected: number;
    readonly maxSelectedReached: boolean;
    private _multiSelectClasses;
    constructor(element: ElementRef, renderer: Renderer2);
    protected optionsUpdateHook(): void;
    selectOption(option: T): void;
    writeValue(values: U[]): void;
    deselectOption(option: T): void;
    onQueryInputKeydown(event: KeyboardEvent): void;
    ngAfterViewInit(): void;
    private onSelectedOptionsRendered();
}
export declare class SuiMultiSelectValueAccessor<T, U> extends CustomValueAccessor<U[], SuiMultiSelect<T, U>> {
    constructor(host: SuiMultiSelect<T, U>);
}
